program NkV;

uses
  SUtil, SCont, SWinUtil, SForm, SCmd, SProf, SConfFile,
  Command, NkVMainForm;

{$R resource.res}

const
  Version = '0.6.1 (2005-05-04)';

procedure LoadPluginList(const FileName: string);
var
  s: string;
begin
  if IsFile(FileName) then
    with TSConfFile.Create(FileName) do
      try
        while GetLineNoParse(s) do
          Plugins.Add(s);
      finally
        Free;
      end
  else
    with TListDir.CreateWithGlob(DirName(ParamStr(0)), '*.spi') do
      try
        while Each(s) do
          if not IsDir then
            Plugins.Add(s);
      finally
        Free;
      end;
end;

var
  ProfDir: string;
  MainForm: TNkVMainForm;
begin
  AppName := 'NkV';
  ProfDir := SProf.ProfDir('NKTOOLSPROF', 'nkv');
  AboutStr := AppName+' '+Version+#13#10#13#10+
    'Copyright (C) 1999-2005 Nobuyuki Honda (Ferdia)'#13#10#13#10+
    'This software is provided under the zlib/libpng license.'#13#10#13#10+
    'Profile Folder: '+ProfDir;

  WallpaperFile := JoinPath(ProfDir, 'wallpaper.bmp');

  try
    Cmd := TSCmd.Create(CmdList, DefaultKeys, JoinPath(ProfDir, 'keymap'));
    Plugins := TSStrList.Create;
    LoadPluginList(JoinPath(ProfDir, 'pluginlist'));
    MainForm := TNkVMainForm.CreateDefaultPos(AppName, 320, 240);
    try
      SetMainForm(MainForm);
      SetAccelerator(Cmd.AccHandle);

      if not MainForm.LoadFile(LongFileName(ParamStr(1))) then
        Exit;

      MainForm.Show;

      ExitCode := MessageLoop;
    finally
      MainForm.Free;
      Plugins.Free;
      Cmd.Free;
    end;
  except
    on E: ESOSError do
    begin
      ShowMsg(E.Msg);
      ExitCode := 255;
    end;
  end;
end.


